/*
 * This is the main class for data storage manager. This class creates
 * database connection, stores data from content arraylist to respective
 * data table.
 */
package thesis;

/**
 * version-4
 * @author titasmutsuddy and Haroonur Rashid
 */
import java.util.*;
import java.sql.*;

public class CreateDBTable {

    Connection conn;
    Statement stmt;
    ResultSet keys;
    PreparedStatement pstmt, pstmtx, pstmtlist, pstmtNoise, pstmtc, pstmtltype, pstmtcn_check, pstmtltype_check;

    public CreateDBTable() {        //null constructor
    }

    /*
     * This method creates data base connection.
     */
    public void initialize() throws Exception {
        //DriverManager.registerDriver();
        DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());
       //conn = DriverManager.getConnection("jdbc:oracle:thin:@localhost:1521:XE","thesiswork", "thesis");
        conn = DriverManager.getConnection("jdbc:oracle:thin:@csoradb1.newcs.uwindsor.ca:1521:cs011","woddlab", "f1pe6t");
        pstmt = conn.prepareStatement("INSERT INTO PRODUCT(BRAND,IMAGE,PROD_NUMBER,PRICE,TEXT,COMPANY_NAME) VALUES(?,?,?,?,?,?)");
        //pstmt = conn.prepareStatement("INSERT INTO PRODUCT(BRAND,IMAGE,PRODUCT_NUM,PRICE,TEXT,COMPANY) VALUES(?,?,?,?,?,?)");
        //pstmtx = conn.prepareStatement("INSERT INTO TEXT (CONTENT,COMPANY)"+ "VALUES (?,?)");
        pstmtx = conn.prepareStatement("INSERT INTO TEXT (TEXT,COMPANY_NAME)"+ "VALUES (?,?)");
        //pstmtlist = conn.prepareStatement("INSERT INTO LIST (LINK,TEXT,COMPANY,LIST_TYPE)"+ "VALUES (?,?,?,?)");
         pstmtlist = conn.prepareStatement("INSERT INTO LIST (LINK,TEXT,COMPANY_NAME,LIST_TYPE)"+ "VALUES (?,?,?,?)");
        //pstmtNoise = conn.prepareStatement("INSERT INTO NOISE (LINK,IMAGE,COMPANY)"+ "VALUES (?,?,?)");
        pstmtNoise = conn.prepareStatement("INSERT INTO NOISE (LINK,IMAGE,COMPANY_NAME)"+ "VALUES (?,?,?)");
        pstmtc = conn.prepareStatement("INSERT INTO COMPANY(COMPANY_NAME) VALUES(?)");
        pstmtltype = conn.prepareStatement("INSERT INTO LIST_TYPE(LIST_TYPE) VALUES(?)");
        pstmtltype_check = conn.prepareStatement("select * from LIST_TYPE");
        pstmtcn_check = conn.prepareStatement("select * from company");
        conn.setAutoCommit(false);
        System.out.println("I am connected");

    }
    /*
     * This method inserts data into respective database table.
     */

    public void insertData(ArrayList arrayList, String s, String cn) {

        if (s.equals("Product") || s.equals("PRODUCT")) {
            Object[] ob = arrayList.toArray();
            insertProductData(ob, cn);
        } else if (s.equals("Text") || s.equals("TEXT")) {
            Object[] ob = arrayList.toArray();
            insertTextData(ob, cn);
        } else if (s.equals("List") || s.equals("LIST")) {
            Object[] ob = arrayList.toArray();
            System.out.println("I am in insertData");
            insertListData(ob, cn);
        } else if (s.equals("Noise") || s.equals("NOISE")) {
            Object[] ob = arrayList.toArray();
            insertNoiseData(ob, cn);
        }
    }
    /*
     * This method inserts noise data into Noise data Table.
     */

    public void insertNoiseData(Object[] ob, String cn) {
        Class cls;
        String name;
        Noise obj = new Noise();
        try {
            for (int i = 1; i < ob.length; i++) {

                cls = ob[i].getClass();
                name = cls.getName();
                if (name.lastIndexOf('.') > 0) {
                    name = name.substring(name.lastIndexOf('.') + 1);
                }
                if (name.equals("Link")) {
                    obj.setLink((Link) (ob[i]));
                } else if (name.equals("Image")) {
                    obj.setImg((Image) (ob[i]));
                } else if (name.equals("CloseSeparator")) {
                    pstmtNoise.setString(1, (obj.getLink()).getRef());
                    pstmtNoise.setString(2, (obj.getImg()).getPath());
                    pstmtNoise.setString(3, cn);
                    pstmtNoise.executeUpdate();
                    conn.commit();
                    pstmtNoise.clearParameters();
                }
            }
        } catch (SQLException e) {
            //System.out.println("Error on Insert" + e);
            e.printStackTrace();
            System.exit(1);
        }
    }
    /*
     * This method inserts list type data into List Type data Table.
     */

    public void insertListType(String ltype) {
        try {

            pstmtltype.setString(1, ltype);
            pstmtltype.executeUpdate();
            conn.commit();
            pstmtltype.clearParameters();

        } catch (SQLException e) {
            //System.out.println("Error on Insert" + e);
            e.printStackTrace();
            System.exit(1);
        }
    }
    /*
     * This method inserts source webpage name data into Company data Table.
     */

    public void insertCompanyName(String cn) {
        boolean flag = true;

        try {
            ResultSet rs = pstmtcn_check.executeQuery();
            while (rs.next()) {
                String lt = rs.getString(2);

                if (lt.equals(cn)) {
                    flag = false;
                    break;
                } else {
                    flag = true;
                }
            }
            if (flag) {

                pstmtc.setString(1, cn);
                pstmtc.executeUpdate();
                conn.commit();
                pstmtc.clearParameters();
            }
        } catch (SQLException e) {
            //System.out.println("Error on Insert" + e);
            e.printStackTrace();
            System.exit(1);
        }
    }
    /*
     * This method inserts list data into List data Table.
     */

    public void insertListData(Object[] ob, String cn) {
        Class cls;
        String name;
        List obj = new List();
        boolean text_flag = true;
        boolean flag = true;

        System.out.println("I am in insertListData");
        try {

            for (int i = 1; i < ob.length; i++) {

                cls = ob[i].getClass();
                name = cls.getName();
                if (name.lastIndexOf('.') > 0) {
                    name = name.substring(name.lastIndexOf('.') + 1);
                }
                if (name.equals("ListType")) {

                    obj.setList_type((ListType) (ob[i]));
                    System.out.println("From class" + (obj.getList_type()).getList_type());
                    ResultSet rs = pstmtltype_check.executeQuery();

                    while (rs.next()) {
                        String lt = rs.getString(2);
                        System.out.println("database" + lt);
                        if (lt.equals((obj.getList_type()).getList_type())) {
                            flag = false;
                            break;
                        } else {
                            flag = true;
                        }
                    }
                    if (flag && (obj.getList_type()).getList_type() != null) {
                        insertListType((obj.getList_type()).getList_type());
                    }
                    /*if(!name.equals(current)){
                    insertListType((obj.getList_type()).getList_type());
                    current=name;
                    }*/
                } else if (name.equals("Link")) {
                    obj.setLink((Link) (ob[i]));
                    text_flag = true;
                } else if (name.equals("Text") && text_flag) {
                    obj.setText((Text) (ob[i]));


                    pstmtlist.setString(1, (obj.getLink()).getRef());
                    pstmtlist.setString(2, (obj.getText()).getContent());
                    pstmtlist.setString(3, cn);
                    pstmtlist.setString(4, (obj.getList_type()).getList_type());
                    System.out.println("record saved");
                    text_flag = false;
                    pstmtlist.executeUpdate();
                    conn.commit();
                    pstmtlist.clearParameters();
                }
            }
        } catch (SQLException e) {
            //System.out.println("Error on Insert" + e);
            e.printStackTrace();
            System.exit(1);
        }
    }
    /*
     * This method inserts text data into Text data Table.
     */

    public void insertTextData(Object[] ob, String cn) {

        Class cls;
        String name;

        try {
            for (int i = 1; i < ob.length - 1; i++) {
                cls = ob[i].getClass();
                name = cls.getName();
                if (name.lastIndexOf('.') > 0) {
                    name = name.substring(name.lastIndexOf('.') + 1);
                }
                if (!name.equals("OpenSeparator")) {
                    if (!name.equals("CloseSeparator")) {
                        pstmtx.setString(1, ((Text) (ob[i])).getContent());
                        pstmtx.setString(2, cn);
                        pstmtx.executeUpdate();
                        conn.commit();
                        pstmtlist.clearParameters();
                    }
                }
            }
        } catch (SQLException e) {
            //System.out.println("Error on Insert" + e);
            e.printStackTrace();
            System.exit(1);

        }

    }

    /*
     * This method inserts product data into Product data Table.
     */
    public void insertProductData(Object[] ob, String cn) {

        Class cls;
        String name;
        Product obj = new Product();
        boolean flag = true;
        try {
            for (int i = 1; i < ob.length; i++) {

                cls = ob[i].getClass();
                name = cls.getName();
                if (name.lastIndexOf('.') > 0) {
                    name = name.substring(name.lastIndexOf('.') + 1);
                }

                if (name.equals("Brand")) {
                    obj.setBrand((Brand) (ob[i]));
                } else if (name.equals("Image") && flag) {
                    obj.setImage((Image) (ob[i]));
                    flag = false;
                } else if (name.equals("Price")) {
                    obj.setPrice((Price) (ob[i]));
                } else if (name.equals("ProdNumber")) {

                    System.out.println(i);
                    obj.setProdNumber((ProdNumber) (ob[i]));
                } else if (name.equals("Title")) {
                    //System.out.println("test-1");
                    obj.setText((Text) (ob[i]));
                } else if (name.equals("CloseSeparator")) {
                    flag = true;
                    //System.out.println("Test2: "+(obj.getText()).getContent());
                    //System.out.println("Test2: "+(obj.getProdNumber()).getProdNumber());
                    pstmt.setString(3, (obj.getProdNumber()).getProdNumber());
                    pstmt.setString(1, (obj.getBrand()).getBrand());
                    pstmt.setString(5, (obj.getText()).getContent());
                    pstmt.setString(2, (obj.getImage()).getPath());
                    pstmt.setString(6, cn);
                    pstmt.setDouble(4, (obj.getPrice()).getPrice());

                    pstmt.executeUpdate();
                    conn.commit();
                    pstmt.clearParameters();
                }
            }
        } catch (SQLException e) {
            //System.out.println("Error on Insert" + e);
            e.printStackTrace();
            System.exit(1);

        }
    }

    public void closeConnection() {
        try {
            conn.close();
        } catch (SQLException e) {
            //System.out.println("Error on Insert" + e);
            e.printStackTrace();
            System.exit(1);

        }
    }
}
